/*
 
 views.h ... Views and Layouts in ℏClipboard.
 
 Copyright (c) 2009, KennyTM~
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
 * Neither the name of the KennyTM~ nor the names of its contributors may be
   used to endorse or promote products derived from this software without
   specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 */

#import "views.h"
#import <iKeyEx/common.h>
#import <iKeyEx/ImageLoader.h>
#import <iKeyEx/KeyboardLoader.h>
#import <iKeyEx/UIKBSpecialKeyButtons.h>
#import <iKeyEx/UIKBSound.h>
#import <UIKit2/Functions.h>
#import <UIKit2/UIKeyboardImpl.h>
//#import "clipboard.h"
//#import "datasource.h"
#import "controller.h"





#pragma mark -

@implementation GestureView

//-(void)flashFirstRowImplicit {
//	// make 0th row visible
//	if (flash0thRow) {
//		[self selectRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] animated:NO scrollPosition:UITableViewScrollPositionNone]; 
//		if (self.contentOffset.y > 0) {
//			[self scrollRectToVisible:CGRectMake(0, 0, 1, 1) animated:YES];
//		} else {
//			[self performSelector:@selector(scrollViewDidEndScrollingAnimation:) withObject:self afterDelay:0.15];
//		}
//		[self performSelector:@selector(reloadData) withObject:nil afterDelay:0.075];
//	}
//}

//-(void)flashFirstRow {
//	flash0thRow = YES;
//	[self flashFirstRowImplicit];	
//}

//-(void)scrollViewDidEndScrollingAnimation:(UIScrollView*)tbl {
//	if (flash0thRow) {
//		flash0thRow = NO;
//		[(UITableView*)tbl deselectRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] animated:YES]; 
//	}
//}

//-(Clipboard*)clipboard { return datasource.clipboard; }
//-(void)setClipboard:(Clipboard*)clpbrd { datasource.clipboard = clpbrd; [self reloadData]; }

-(void)dealloc {
	[_target release];
//	[datasource release];
	[super dealloc];
}

//-(void)tableView:(UITableView*)tbl didSelectRowAtIndexPath:(NSIndexPath*)indexPath {
//	Clipboard* clpbrd = datasource.clipboard;
//	NSUInteger row = indexPath.row;
//	[clpbrd updateEntryAtReversedIndex:row];
//	if (_action != NULL) {
//		[_target performSelector:_action withObject:[clpbrd lastData] withObject:tbl];
//	}
//	
//	[UIKBSound play];
//	
//	// If you're expect in Graphics Design, please suggest a better, workable animation sequence :)
//	[tbl deselectRowAtIndexPath:indexPath animated:YES];
//	flash0thRow = (row > 0);
//	[self flashFirstRowImplicit];
//}

//-(BOOL)pointInside:(CGPoint)point withEvent:(UIEvent*)event {
//	// avoid crash on swipe
//	if (event == nil)
//		return NO;
//	// avoid crash on swipe when the board is empty.
//	// See http://discussions.apple.com/thread.jspa?messageID=8439372 for detail.
//	else if ([datasource tableView:self numberOfRowsInSection:0] == 0)
//		return NO;
//	else
//		return CGRectContainsPoint(self.bounds, point);
//}

-(id)initWithFrame:(CGRect)frm {
	if ((self = [super initWithFrame:frm])) {
//		self.rowHeight = 32;
//		self.separatorStyle = UITableViewCellSeparatorStyleNone;
		//self.backgroundColor = [UIColor clearColor];
		self.backgroundColor = [UIColor whiteColor];
//		datasource = [[hCClipboardDataSource alloc] init];
//		self.dataSource = datasource;
//		self.delegate = self;
		_target = nil;
		_action = NULL;
//		self.scrollsToTop = NO;
		
//		emptyClipboardIndicator = [[UILabel alloc] initWithFrame:CGRectZero];
//		emptyClipboardIndicator.textColor = [UIColor whiteColor];
//		emptyClipboardIndicator.shadowColor = [UIColor colorWithWhite:0 alpha:0.5];
//		emptyClipboardIndicator.font = [UIFont boldSystemFontOfSize:[UIFont smallSystemFontSize]];
//		emptyClipboardIndicator.textAlignment = UITextAlignmentCenter;
//		emptyClipboardIndicator.backgroundColor = [UIColor clearColor];
//		[self addSubview:emptyClipboardIndicator];
//		[emptyClipboardIndicator release];
		
//		[self reloadData];



	}
	return self;
}

-(void)setTarget:(id)target action:(SEL)action {
	if (target != _target) {
		[_target release];
		_target = [target retain];
	}
	_action = action;
}

-(void)layoutSubviews {
	[super layoutSubviews];
//	if ([datasource tableView:self numberOfRowsInSection:0] == 0) {
//		emptyClipboardIndicator.hidden = NO;
//		CGFloat h = [@"|" sizeWithFont:emptyClipboardIndicator.font].height;
//		CGSize frameSize = self.frame.size;
//		emptyClipboardIndicator.frame = CGRectMake(0, round((frameSize.height-h)*0.5), frameSize.width, h);
//	} else
//		emptyClipboardIndicator.hidden = YES;
}
//-(void)setPlaceholderText:(NSString*)txt { emptyClipboardIndicator.text = txt; }
//-(BOOL)switchClipboard {
//	BOOL result = [datasource switchClipboard];
//	[self reloadData];
//	return result;
//}

//-(BOOL)isDefaultClipboard { return datasource.usesPrefix; }



@end





//@implementation hCVerticalToolBar

//@synthesize columns;

//-(void)layoutSubviews {
//	CGSize btnSize = self.bounds.size;
//	btnSize.height = round(btnSize.height * columns / ([self.subviews count]));
//	if (columns > 1)
//		btnSize.width = round(btnSize.width / columns);
//	CGFloat y = 0;
//	CGFloat x = 0;
//	NSUInteger i = 0;
//	for (UIButton* btn in self.subviews) {
//		btn.frame = CGRectMake(x, y, btnSize.width, btnSize.height);
//		++ i;
//		if (i < columns) {
//			x += btnSize.width;
//		} else {
//			x = 0;
//			i = 0;
//			y += btnSize.height;
//		}
//	}
//}
//-(UIButton*)addButtonWithImage:(UIImage*)img target:(id)target action:(SEL)action {
//	UIButton* newBtn = [UIButton buttonWithType:UIButtonTypeCustom];
//	newBtn.showsTouchWhenHighlighted = YES;
//	[newBtn setImage:img forState:UIControlStateNormal];
//	[newBtn addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];
//	[self addSubview:newBtn];
//	[self layoutIfNeeded];
//	return newBtn;
//}

//-(id)initWithFrame:(CGRect)frm {
//	if ((self = [super initWithFrame:frm])) {
//		columns = 1;
//	}
//	return self;
//}
//@end


@implementation hGestureLayout


@synthesize gestureView;
-(id)initWithFrame:(CGRect)frm {
	if ((self = (hGestureLayout*)[super initWithFrame:frm])) {
		NSBundle* thisBundle = [KeyboardBundle activeBundle].bundle;
		keyboardAppearance = UIKeyboardAppearanceDefault;
		
		
		
		controller = [[hGestureLayoutController alloc] init];
		controller.view = self;
		controller.bundle = thisBundle;
		
		calloutShower = [[UICalloutViewShower alloc] initWithView:self];
		
		backgroundView = [[UIImageView alloc] initWithFrame:frm];
		[self addSubview:backgroundView];
		[backgroundView release];
		
		spBtnGroup = [[UIKBButtonsGroup alloc] initWithLandscape:NO appearance:UIKeyboardAppearanceDefault];
		[spBtnGroup addSubviewWithClass:[UIKBInternationalButton class]];
		[spBtnGroup addSubviewWithClass:[UIKBSpaceBarButton class]];
		[spBtnGroup addSubviewWithClass:[UIKBReturnKeyButton class]];
		[spBtnGroup addSubviewWithClass:[UIKBDeleteKeyButton class]];
//		switchClipboardButton = [[UIKBSpecialKeyButton alloc] init];
//		switchClipboardButton.showsTouchWhenHighlighted = YES;
//		[switchClipboardButton addTarget:controller
//								  action:@selector(switchClipboard:)
//							forControlEvents:UIControlEventTouchUpInside];
//		[switchClipboardButton setImage:[UIImage imageWithContentsOfFile:[thisBundle pathForResource:@"toTemplate" ofType:@"png"]]
//								   forState:UIControlStateNormal];
//		[calloutShower registerButton:switchClipboardButton
//					withCalloutString:[thisBundle localizedStringForKey:@"Switch to Templates" value:nil table:nil]];
//		[UIKBSound registerButton:switchClipboardButton];
//		[spBtnGroup addSubview:switchClipboardButton];
//		[switchClipboardButton release];
		[self addSubview:spBtnGroup];
		[spBtnGroup release];
		
//		toolbar = [[hCVerticalToolBar alloc] initWithFrame:CGRectZero];
//		
//		copyBtn = [toolbar addButtonWithImage:[UIImage imageWithContentsOfFile:[thisBundle pathForResource:@"copy" ofType:@"png"]]
//									   target:controller
//									   action:@selector(copyText)];
//		[calloutShower registerButton:copyBtn withCalloutString:[thisBundle localizedStringForKey:@"Copy" value:nil table:nil]];
//		[UIKBSound registerButton:copyBtn];
//		
//		markSelBtn = [toolbar addButtonWithImage:[UIImage imageWithContentsOfFile:[thisBundle pathForResource:@"selectStart" ofType:@"png"]]
//										  target:controller
//										  action:@selector(markSelection:)];
//		[calloutShower registerButton:markSelBtn withCalloutString:[thisBundle localizedStringForKey:@"Select from here..." value:nil table:nil]];
//		[UIKBSound registerButton:markSelBtn];
//		
//		
//		UIButton* btn = [toolbar addButtonWithImage:_UIImageWithName(@"UIButtonBarPreviousSlide.png")
//											 target:controller
//											 action:@selector(moveToBeginning)];
//		[calloutShower registerButton:btn withCalloutString:[thisBundle localizedStringForKey:@"Move to beginning" value:nil table:nil]];
//		[UIKBSound registerButton:btn];
//		
//		btn = [toolbar addButtonWithImage:_UIImageWithName(@"UIButtonBarNextSlide.png")
//								   target:controller
//								   action:@selector(moveToEnd)];
//		[calloutShower registerButton:btn withCalloutString:[thisBundle localizedStringForKey:@"Move to end" value:nil table:nil]];
//		[UIKBSound registerButton:btn];
//		
//		[self addSubview:toolbar];
//		[toolbar release];
		
		gestureView = [[GestureView alloc] initWithFrame:CGRectZero];
		//[gestureView setTarget:controller action:@selector(paste:)];
		//[gestureView setPlaceholderText:[thisBundle localizedStringForKey:@"Clipboard is empty" value:nil table:nil]];
		[self addSubview:gestureView];
		[gestureView release];
		
		[self layoutIfNeeded];
		
		//for Gesture
		[self initData];
		gestures = [[NSMutableArray alloc]init];
		moves = [[NSMutableArray alloc]init];
		[self testGesture];
	}
	return self;
}

-(void)layoutSubviews {
	int ori = [[UIKeyboardImpl sharedInstance] orientation];
	BOOL landsc = (ori == 90 || ori == -90);
	if (!landsc) {
//		toolbar.columns = 1;
//		toolbar.frame = CGRectMake(320-36, 0, 36, 116);
		gestureView.frame = CGRectMake(8, 8, 320-36-16, 172-16);
	} else {
//		toolbar.columns = 2;
//		toolbar.frame = CGRectMake(480-72, 8, 72, 64);
		gestureView.frame = CGRectMake(8, 8, 480-72-16, 119-16);
	}
	[toolbar setNeedsLayout];
	
	spBtnGroup.landscape = landsc;
	backgroundView.image = UIKBGetImage(UIKBImageBackground, keyboardAppearance, landsc);
	backgroundView.frame = spBtnGroup.frame;
	
	CGRect bdyRect = self.bounds;
	bdyRect.origin.y = -bdyRect.size.height;
	bdyRect.size.height += bdyRect.size.height;
	calloutShower.boundaryRect = bdyRect;
	
//	switchClipboardButton.frame = [UIKBPlaneChooserButton defaultFrameWithLandscape:landsc];
}

-(void)showKeyboardType:(UIKeyboardType)type withAppearance:(UIKeyboardAppearance)appr {
	UIKeyboardImpl* impl = [UIKeyboardImpl sharedInstance];
	int ori = [impl orientation];
	BOOL landsc = (ori == 90 || ori == -90);
	keyboardAppearance = appr;
	
	backgroundView.image = UIKBGetImage(UIKBImageBackground, appr, landsc);
	spBtnGroup.keyboardAppearance = appr;
	backgroundView.frame = spBtnGroup.frame;
	
	//BOOL disableCopyKeys = ![impl textInputTraits].secureTextEntry;
//	copyBtn.enabled = disableCopyKeys;
//	markSelBtn.enabled = disableCopyKeys;
	
	[self setNeedsLayout];
}

-(void)updateReturnKey {
	UIKBReturnKeyButton* retKey = (UIKBReturnKeyButton*)[spBtnGroup firstSubviewWithClass:[UIKBReturnKeyButton class]];
	if (retKey != nil) {
		UIKeyboardImpl* impl = [UIKeyboardImpl sharedInstance];
		retKey.returnKeyType = impl.returnKeyType;
		retKey.enabled = impl.returnKeyEnabled;
	}
}


-(void)dealloc {
	[gestures removeAllObjects];
	[gestures release];
	[moves removeAllObjects];
	[moves release];
	
	[calloutShower release];
	[controller release];
	[super dealloc];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event 
{ 
	
//	CGPoint pt = [[touches anyObject] locationInView:self]; 
		
//	NSLog(@"StartGesture/n");
//	//WFX`[eNA
//	if([curGesture count]>0)
//	{
//		[curGesture removeAllObjects];
//	}
//	if([curGesturePoint count]>0)
//	{
//		[curGesturePoint removeAllObjects];
//		
//	}
//	//ʒuZbg
	
	CGPoint pt = [[touches anyObject] locationInView:self]; 

	lastPoint.x = pt.x;
	lastPoint.y = pt.y;

	rect.origin.x = 1000;
	rect.origin.y = 1000;
	rect.size.width = 0;
	rect.size.height = 0;

	[moves removeAllObjects];
	[points removeAllObjects];

	[self setNeedsDisplay]; 	
	
	
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event 
{ 
	
	CGPoint pt = [[touches anyObject] locationInView:self]; 
	// calcul dif 
	int msx = pt.x;//  ݂̃}EXʒu
	int msy = pt.y;
	
	int difx = msx - lastPoint.x;  //OƂ̍
	int dify = msy - lastPoint.y;
	float sqDist=difx*difx+dify*dify;// OƂ̋
	float sqPrec= DEFAULT_PRECISION * DEFAULT_PRECISION;
	
	if (sqDist>sqPrec){ //OƂ̋ȏゾ
		[points addObject:[NSValue valueWithCGPoint:CGPointMake(msx,msy)]];// |CgPUSH
		[self addMove:difx dify:dify];              //ړPUSH
		lastPoint.x=msx;                 //Ō̈ʒu
		lastPoint.y=msy;
		
		if (msx<rect.origin.x)rect.origin.x=msx; //p̋` {rect̎gƂ͈ႤǁcB
		if (msx>rect.size.width)rect.size.width=msx;
		if (msy<rect.origin.y)rect.origin.y=msy;
		if (msy>rect.size.height)rect.size.height=msy;
	}
	
	[self setNeedsDisplay]; 	
}


- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event 
{ 

		[self matchGesture]; //o
	[moves removeAllObjects];
	[points removeAllObjects];

	[self setNeedsDisplay]; 	

}


- (void)drawRect:(CGRect)rect {
    // Drawing code
	// Get the current context 
	CGContextRef context = UIGraphicsGetCurrentContext(); 

	CGPoint prePoint;
	prePoint.x = -1;
	prePoint.y = -1;
	
	for(int nCount = 0;nCount < [points count];nCount++)
	{

		CGPoint curPoint;
		curPoint = [[points objectAtIndex:nCount]CGPointValue];
		
		if(prePoint.x = -1)
		{
			prePoint.x = curPoint.x;
			prePoint.y = curPoint.y;
		}
	
		CGContextSetLineWidth(context, 5.0f); 
		CGFloat gray[4] = {0.5f, 0.5f, 0.5f, 1.0f}; 
		CGContextSetStrokeColor(context, gray); 
		CGFloat red[4] = {0.75f, 0.25f, 0.25f, 1.0f}; 
		CGContextSetFillColor(context, red); 
	
		// Draw a line between the two location points 
		CGContextMoveToPoint(context, prePoint.x, prePoint.y); 
		CGContextAddLineToPoint(context, curPoint.x, curPoint.y); 
		CGContextStrokePath(context); 
		prePoint.x = curPoint.x;
		prePoint.y = curPoint.y;

	}
}



-(void)addGesture:(NSString*)o gesture:(NSString*)gesture matchHandler:(id)matchHandler
{
	NSMutableArray *g=[[[NSMutableArray alloc]initWithCapacity:1]autorelease ];
	for (uint i=0;i<gesture.length;i++){
		if([[gesture substringWithRange:NSMakeRange(i,1)]compare:@"."]==NSOrderedSame)
		{
			[g addObject:[NSNumber numberWithInt:-1]];
		}
		else
		{
			[g addObject:[NSNumber numberWithInt:[[gesture substringWithRange:NSMakeRange(i,1)]intValue]]];			
		}		 
	}
	gestureInfo *gInfo = [[[gestureInfo alloc] initWithGestureData:o moves:g match:matchHandler]autorelease]; 
	[gestures addObject:gInfo];
}


-(void)initData
{
	[self buildAnglesMap];
	[gestures removeAllObjects];
	
}

//AO}bv
-(void) buildAnglesMap
{
	
	// Angle of one sector
	sectorRad=M_PI*2/DEFAULT_NB_SECTORS;
	
	// map containing sectors no from 0 to PI*2
	anglesMap=[[NSMutableArray alloc] initWithCapacity:1];
	
	// the precision is Math.PI*2/100
	float step =M_PI*2/100;
	
	// memorize sectors
	int sector;
	for (float i=-sectorRad/2;i<=M_PI*2-sectorRad/2;i+=step){
		sector=floor((i+sectorRad/2)/sectorRad);
		[anglesMap addObject:[NSNumber numberWithInt:sector]];
	}
}	


-(void) addMove:(int)dx dify:(int)dy
{
	float angle=atan2(dy,dx)+sectorRad/2;
	if (angle<0)angle+=M_PI*2;
	int no=floorf(angle/(M_PI*2)*100);
	[moves addObject:[anglesMap objectAtIndex:no]];//  ړԍ𔻒APUSH
}		


-(void)matchGesture
{
	
	uint bestCost = 1000000;  //RXgl
	uint nbGestures =[gestures count]; //`FbNWFX`[̐
	uint cost;//vZRXg
	//NSArray *gest;  //ܔrWFX`[
	gestureInfo * bestGesture = nil;  
	gestureInfo *infos
		= [[gestureInfo alloc]initWithGestureData2:moves lastPoint:lastPoint rect:rect];

	for (uint i=0;i < nbGestures;i++){ // `FbNΏۃWFX`[̐
		
		
		
		NSArray *gest = [[NSArray alloc]initWithArray:((gestureInfo*)[gestures objectAtIndex:i]).moves]; //`FbNWFX`[̈ړꗗ
		
		infos.datas= [NSString stringWithString:((gestureInfo*)[gestures objectAtIndex:i]).datas]; // WFX`[Ɉvꍇ̕
		
		cost=[self costLeven:gest b:moves]; // RXgvZ
		
		if (cost<=DEFAULT_FIABILITY){ 
			if (((gestureInfo*)[gestures objectAtIndex:i]).matchHandler!=nil){// ʊ֐Ȃ
				infos.cost=cost;
				//cost=[((gestureInfo*)[gestures objectAtIndex:i]).matchHandler infos]; //֐Ăяo
			}
			if (cost<bestCost){
				bestCost=cost;
				bestGesture=(gestureInfo*)[gestures objectAtIndex:i];
			}
		}
	}
	
	
	if (bestGesture!=nil){
		[controller paste:bestGesture.datas];
		
	}else{
		//dispatchEvent(new GestureEvent(GestureEvent.NO_MATCH));
	}
}


//px̍				
-(uint) difAngle:(uint)a b:(uint)b
{
	uint dif=abs(a-b);
	if (dif>DEFAULT_NB_SECTORS/2)dif=DEFAULT_NB_SECTORS-dif;
	return dif;
}


-(uint) costLeven:(NSArray*)a b:(NSArray*)b
{	
	// point
	if ([a objectAtIndex:0]==-1)
	{
		return [b count]==0 ? 0 : 100000;
	}
	
	// precalc difangles
	//var d:Array=fill2DTable(a.length+1,b.length+1,0);
	uint d[100][100] = {0};
	uint w[100][100] = {0};
	
	
	//var w:Array=d.slice(); //쐬
	uint x = 0;
	uint y = 0;
	for (x=1;x<=[a count];x++){
		for (y=1;y<[b count];y++){
			d[x][y]=[self difAngle:[[a objectAtIndex:x-1]intValue] b:[[b objectAtIndex:y-1]intValue]];
		}
	}
	
	// max cost
	for ( y=1;y<=[b count];y++)w[0][y]=100000;
	for ( x=1;x<=[a count];x++)w[x][0]=100000;
	w[0][0]=0;
	
	// levensthein application
	uint cost=0;
	uint pa;
	uint pb;
	uint pc;
	
	for ( x=1;x<=[a count];x++)
	{
		for ( y=1;y<[b count];y++)
		{
			cost=d[x][y];
			pa=w[x-1][y]+cost;
			pb=w[x][y-1]+cost;
			pc=w[x-1][y-1]+cost;
			int min = pa;
			if(min > pb)
			{
				min = pb;
			}
			if(min > pc)
			{
				min = pc;
			}
			
			w[x][y]=min;
		}
	}
	
	return w[x-1][y-1];
}	

-(void)testGesture
{
	[self addGesture:@"A" gesture:@"71" matchHandler:nil];
	[self addGesture:@"B" gesture:@"260123401234" matchHandler:nil];
	[self addGesture:@"C" gesture:@"43210" matchHandler:nil];
	[self addGesture:@"D" gesture:@"26701234" matchHandler:nil];
	[self addGesture:@"E" gesture:@"4321043210" matchHandler:nil];
	[self addGesture:@"F" gesture:@"42" matchHandler:nil];
	[self addGesture:@"G" gesture:@"432107650" matchHandler:nil];
	[self addGesture:@"H" gesture:@"267012" matchHandler:nil];
	[self addGesture:@"I" gesture:@"2" matchHandler:nil];
	[self addGesture:@"J" gesture:@"234" matchHandler:nil];
	[self addGesture:@"K" gesture:@"3456701" matchHandler:nil];
	[self addGesture:@"L" gesture:@"20" matchHandler:nil];
	[self addGesture:@"M" gesture:@"6172" matchHandler:nil];
	[self addGesture:@"N" gesture:@"616" matchHandler:nil];
	[self addGesture:@"O" gesture:@"432107654" matchHandler:nil];
	[self addGesture:@"P" gesture:@"26701234" matchHandler:nil];
	[self addGesture:@"Q" gesture:@"4321076540" matchHandler:nil];
	[self addGesture:@"R" gesture:@"267012341" matchHandler:nil];
	[self addGesture:@"S" gesture:@"432101234" matchHandler:nil];
	[self addGesture:@"T" gesture:@"02" matchHandler:nil];
	[self addGesture:@"U" gesture:@"21076" matchHandler:nil];
	[self addGesture:@"V" gesture:@"17" matchHandler:nil];
	[self addGesture:@"W" gesture:@"2716" matchHandler:nil];
	[self addGesture:@"X" gesture:@"1076543" matchHandler:nil];
	[self addGesture:@"Y" gesture:@"21076234567" matchHandler:nil];
	[self addGesture:@"Z" gesture:@"030" matchHandler:nil];
	
	[self addGesture:@"0" gesture:@"4321076542" matchHandler:nil];
	[self addGesture:@"1" gesture:@"2" matchHandler:nil];
	[self addGesture:@"2" gesture:@"701230" matchHandler:nil];
	[self addGesture:@"3" gesture:@"0123401234" matchHandler:nil];
	[self addGesture:@"4" gesture:@"302" matchHandler:nil];
	[self addGesture:@"5" gesture:@"4201234" matchHandler:nil];
	[self addGesture:@"6" gesture:@"43210765" matchHandler:nil];
	[self addGesture:@"7" gesture:@"03" matchHandler:nil];
	[self addGesture:@"8" gesture:@"4321234567654" matchHandler:nil];
	[self addGesture:@"9" gesture:@"43210762" matchHandler:nil];
	
	[self addGesture:@"BACKSPACE" gesture:@"4" matchHandler:nil];
	[self addGesture:@"SPACE" gesture:@"0" matchHandler:nil];
	 [self addGesture:@"DOT" gesture:@"." matchHandler:nil];			
	 }


@end



@implementation gestureInfo

@synthesize datas,moves,matchHandler,cost;
;

-(gestureInfo*)initWithGestureData:(NSString*)in_datas moves:(NSMutableArray*)in_moves match:(id)in_matchHandler
{
	datas = [[NSString alloc]initWithString:in_datas];
	moves = [[NSArray alloc]initWithArray:in_moves];
	matchHandler = in_matchHandler;
	
	return self;	
}

-(gestureInfo*)initWithGestureData2:(NSMutableArray*)in_moves 
						 lastPoint:(CGPoint)in_lastPoint rect:(CGRect)in_rect
{
	//datas = [[NSString alloc]initWithString:in_datas];
	moves = [[NSArray alloc]initWithArray:in_moves];

	//matchHandler = in_matchHandler;
	lastPoint.x = in_lastPoint.x;
	lastPoint.y = in_lastPoint.y;
	rect.origin.x = in_rect.origin.x;
	rect.origin.y = in_rect.origin.y;
	rect.size.width = in_rect.size.width; 
	rect.size.height = in_rect.size.height;
	return self;	
}


- (void)dealloc {
    [datas release];
    [moves release];
    [super dealloc];
}
@end
